#!/bin/bash

import os, re, string
from random import *

def openFile(filename, mode):
  try:
    fd = open(filename, mode);
  except ValuesError:
    print "ValuesError: [readFile] Program exiting...\n";
    os.exit(1);
  except IOError:
    print "IOError: [readFile] Program exiting...\n";
    os.exit(1);
  
  return fd;

def makeFile(destination):
  print "Moving old files...",
  os.system("mv DSDVMultiHopAppP.nc oldDSDVMultiHopAppP.nc");
  os.system("mv driver_dsdv.py oldDriver.py");
  print "done.";
  
  #open old files
  print "Openning old files...",
  app = openFile("oldDSDVMultiHopAppP.nc", "r");
  py = openFile("oldDriver.py", "r");
  print "done.";
  
  #create and open new files
  print "Creating and openning new files...",
  nApp = openFile("DSDVMultiHopAppP.nc", "w");
  nPy = openFile("driver_dsdv.py", "w");
  print "done.";
  
  print "Copying data to new files...",
  appLines = app.readlines();
  for line in appLines:
    found = re.compile("#define BASE_STATION_NODEID(.*)").search(line);
    if found:
      txt = ("#define BASE_STATION_NODEID %d\n")%(destination);
      nApp.writelines(txt);
    else:
      nApp.writelines(line);
    
  pyLines = py.readlines();
  for line in pyLines:
    found = re.compile("(.*)RcvAddr =(.*)").search(line);
    if found:
      txt = ("RcvAddr = %d;\n")%(destination);
      nPy.writelines(txt);
    else:
      nPy.writelines(line);
  
  app.close();
  nApp.close();
  py.close();
  nPy.close();
  print "done.";
  
  os.system("rm oldDSDVMultiHopAppP.nc oldDriver.py");
  os.system("make micaz sim");

def usedSeeds():
  seeds = [];
  values = openFile("values.txt", "r");
  lines = values.readlines();
  for line in lines:
    found = re.compile("(.*)seed:(.*)").search(line);
    if found:
      seed = found.group(2);
      seeds.append(seed.strip());
  values.close();
  
  return seeds;

def collectData(seeds, node):
  values = openFile("values.txt", "r");
  lines = values.readlines();
  PER = txPkt = TxTime = rcvData = throughput = 0;
  for line in lines:
    time = re.compile("(.*)time:(.*)ms(.*)").search(line);
    rcv = re.compile("(.*)rcved:(.*)").search(line);
    n = re.compile("n:(.*)::(.*)").search(line);
    p = re.compile("PER:(.*)::(.*)").search(line);
    
    if time:
      TxTime += float(time.group(2));
    if rcv:
      rcvData += float(rcv.group(2));
    if n:
      txPkt += float(n.group(1));
    if p:
      PER += float(p.group(1));
  
  #print TxTime, rcvData, txPkt;
  total = 0;
  for seed in seeds:
    res_file = ("res%s.txt") % seed;
    res = openFile(res_file, "r");
    
    lines = res.readlines();
    for line in lines:
      found = re.compile("(.*) (.*) (.*)").search(line);
      if found:
        total += float(found.group(3)) - float(found.group(2));
  
  throughput = (float(rcvData * 16)/ float(TxTime/1000))
  
  stats = openFile("stats.txt", "a");
  line_stats = ("%.5f %.5f %.5f %.5f\n") % (throughput, (txPkt/len(seeds)), float((total/rcvData)/1000), (PER/10));
  stats.writelines(line_stats);
  stats.close();
  
  print "Throughput: ", throughput, "bps | PER:", (PER/10), " tx/packet:", (txPkt/len(seeds)), 
  print " packets | avg delay:", total, float((total/rcvData)/1000), "s\n" ;
  
  print "Moving results to simulations directory...",
  dir = ("mkdir -p sims/0to%d")%(node);
  mv = ("mv res* log* values.txt stats.txt sims/0to%d")%(node);
  os.system(dir);
  os.system(mv);
  print "done.";

nodes = [1,2,3,4,5,6,7]

for node in nodes:
  makeFile(node);
  for i in range(0,10):
    os.system("python driver_dsdv.py");
  collectData(usedSeeds(), node);
