
from TOSSIM import *
from random import *
import sys

t = Tossim([])
m = t.mac();
r = t.radio();

# Debug Messages
log = open("log.txt", "w")

# Save to file.
#t.addChannel("DSDV", log )
t.addChannel("MultiHopAppP", log )
#t.addChannel("QueuedSendP", log )
#t.addChannel("MHEngine", log )
#t.addChannel("LedsC", log )
#t.addChannel("DEBUG", log )

# Send to stdout
t.addChannel("MultiHopAppP", sys.stdout )
#t.addChannel("LedsC", sys.stdout )
#t.addChannel("DSDV", sys.stdout )
#t.addChannel("QueuedSendP", sys.stdout )
#t.addChannel("MHEngine", sys.stdout )
#t.addChannel("DEBUG", sys.stdout )

# Number of nodes in the topologie
nNodes = 4

print "Reading the topologie of the network."
# Reading the topologie of the network.
f = open("topo/topo.txt", "r")
lines = f.readlines()
for line in lines:
  s = line.split()
  if (len(s) > 0):
    if s[0] == "gain":
      r.add(int(s[1]), int(s[2]), float(s[3]))
    elif s[0] == "noise":
      r.setNoise(int(s[1]), float(s[2]), float(s[3]))

print "Reading noise values."
# Reading noise values.
noise = open("noise/meyer.txt", "r")
lines = noise.readlines()
for line in lines:
    str = line.strip()
    if (str != ""):
        val = int(str)
        for i in range(0, nNodes):
            t.getNode(i).addNoiseTraceReading(val)

print "Inicialization of the nodes."
# Inicialization of the nodes.
for i in range(0, nNodes):
	m = t.getNode(i);
	time = randint(t.ticksPerSecond(), 10 * t.ticksPerSecond())
	m.bootAtTime(time)
	m.createNoiseModel();
	print "Booting ", i, " at time ", time/t.ticksPerSecond()," seg"
	
print "Starting simulation."
# Running the simulation.
f = 1;
while(f):
	f = t.runNextEvent()
