
from TOSSIM import *
from random import *
from time import *
import sys
import threading



t = Tossim([])
m = t.mac();
r = t.radio();

seed = randint(0, 99999999);
t.randomSeed(31735000); #31735000

# Debug Messages
log = open("log.txt", "w");

used_seed = ("used seed: %d\n") %(seed);
log.write(used_seed);

# Save to file.
t.addChannel("DTSNSenderReceiverC", log );
t.addChannel("DTSN", log );


# Send to stdout
t.addChannel("DTSNSenderReceiverC", sys.stdout );
t.addChannel("DTSN", sys.stdout );

# Number of nodes in the topologie
nNodes = 3

print "Reading the topologie of the network."
# Reading the topologie of the network.
f = open("topo/topo.txt", "r")
lines = f.readlines()
for line in lines:
  s = line.split()
  if (len(s) > 0):
    if s[0] == "gain":
      r.add(int(s[1]), int(s[2]), float(s[3]))
    elif s[0] == "noise":
      r.setNoise(int(s[1]), float(s[2]), float(s[3]))

print "Reading noise values."
# Reading noise values.
noise = open("noise/meyer.txt", "r")
lines = noise.readlines()
for line in lines:
    str = line.strip()
    if (str != ""):
        val = int(str)
        for i in range(0, nNodes):
            t.getNode(i).addNoiseTraceReading(val)

print "Inicialization of the nodes."
# Inicialization of the nodes.
for i in range(0, nNodes):
	m = t.getNode(i);
	time = randint(t.ticksPerSecond(), 10 * t.ticksPerSecond())
	m.bootAtTime(1)
	m.createNoiseModel();
	print "Booting ", i, " at time ", time/t.ticksPerSecond()," seg"
	

print "Starting simulation."

sink = t.getNode(0);
nOne = t.getNode(1);
nTwo = t.getNode(2);

def OnOff():
	"""
	nOne.turnOff();
	nTwo.turnOff();
	nOne.turnOn();
	nTwo.turnOn();
	"""
	r.remove(0,1);
	r.remove(1,0);
	r.add(0,2,-70);
	r.add(2,0,-70);
	if r.connected(0,1) == 0:
		log.write("[TOSSIM][Radio] 0 not connected to 1!!\n");
	else:
		log.write("[TOSSIM][Radio] 0 connected to 1!!\n");
	if r.connected(0,2) == 1:
		log.write("[TOSSIM][Radio] 0 connected to 2!!\n");
	else:
		log.write("[TOSSIM][Radio] 0 not connected to 2!!\n");
	if r.connected(2,1) == 1:
		log.write("[TOSSIM][Radio] 2 connected to 1!!\n");
	else:
		log.write("[TOSSIM][Radio] 2 not connected to 1!!\n");
	#log.write("[TOSSIM] OFF/ON!!\n");
	log.write("[TOSSIM] TOP CHANGE!!\n");
	cont();

"""
def twoOnOff():
	nTwo.turnOff();
	nTwo.turnOn();
	log.write("[TOSSIM] Node 2 off/on!!\n");
	cont();

def sinkOnOff():
	sink.turnOff();
	sink.turnOn();
	log.write("[TOSSIM] Sink off/on!!\n");
	cont();
"""

def cont():
	f = 1;
	while(f):	
		f = t.runNextEvent()

"""
tm = [];
flag = 1;
for i in range(0,60):
	if i % 5 == 0:
		if flag == 1:
			tm.append(threading.Timer(i, oneOnOff));
			flag = 2;
			continue;
		if flag == 2:
			tm.append(threading.Timer(i, twoOnOff));
			flag = 0;
			continue;
		if flag == 0:
			tm.append(threading.Timer(i, sinkOnOff));
			flag = 1;

for i in range(0,len(tm)):
	tm[i].start();
"""

tm = threading.Timer(60, OnOff);
tm.start();


# Running the simulation.
cont()
