/*
This software licensed to you subject to the following terms and conditions
which you accepted by clicking "Accept" in order to enable the downloading
of this software

1.    In consideration of you agreeing to abide by the terms of this
Agreement, the Licensor hereby grants to you a non-exclusive,
non-transferable license to use the Software and derivations or variations
of the Software on the terms of this Agreement.
2.    You may download, install, use, modify, vary, and adapt the Software.
3.    Except as expressly set out in this Agreement or as permitted by any
mandatory law, you undertake:

    a.    not to copy the Software or except where such copying is
incidental to normal use of the Software, or where it is necessary for the
purpose of back-up or operational security;
    b.    to include the copyright notice of the Licensor on all entire and
partial copies you make of the Software or any variations or derivation of
the Software on any medium;
    c.    not to sublicense the Software or variations or derivations of the
Software to any person without INOV?s written consent.

4.    You acknowledge that all intellectual property rights in the Software,
and any modifications, or variations thereto, anywhere in the world belong
to INOV, or its licensors, that rights in the Software are licensed (not
sold) to you, and that you have no rights in, or to, the Software other than
the right to use them in accordance with the terms of this Agreement.
5.    Nothing in this Agreement shall exclude or in any way limit the
Licensor's liability for fraud, or for death or personal injury caused by
its negligence or any other liability to the extent that it may not be
excluded or limited as a matter of law.
6.    Subject to clause 5  the Licensor shall not be liable under, or in
connection with, this Agreement or any collateral contract for:
    a.    loss of income;
    b.    loss of business profits or contracts;
    c.    business interruption;
    d.    loss of the use of money or anticipated savings;
    e.    loss of information;
    f .    loss of opportunity, goodwill or reputation;
    g.    loss of, damage to or corruption of data; or
    h.    any indirect or consequential loss or damage of any kind howsoever
arising and whether caused by tort (including negligence), breach of
contract or otherwise.
7.    Subject to clauses 5 and 6, the Licensor's maximum aggregate liability
under or in connection with this Agreement, or any collateral contract,
whether in contract, tort (including negligence) or otherwise, shall be
limited to a sum of  100.
8.    This Agreement sets out the full extent of the Licensor's obligations
and liabilities in respect of the supply of the Software. The Software is
provided ?as is?, and there are no conditions, warranties, representations
or other terms, express or implied, that are binding on the Licensor except
as specifically stated in this Agreement.  Any condition, warranty,
representation or other term concerning the supply of the Software which
might otherwise be implied into, or incorporated in, this Agreement, or any
collateral contract, whether by statute, common law or otherwise, is hereby
excluded to the fullest extent permitted by law.
9.    The Licensor may terminate this Agreement on giving you not less than
28 days written notice, or may terminate this Agreement immediately by
written notice to you if:
    a.    You commit a material or persistent breach of this Agreement which
you fail to remedy (if remediable) within 14 days after the service of
written notice requiring you to do so; or
    b.    You undergo a change of control.
10.    Upon termination for any reason:
    a.    all rights granted to you under this Agreement shall cease;
    b.    you must cease all activities authorised by this Agreement;
    c.    you must immediately delete or remove the Software or derivations
or variations thereto from all computer equipment in your possession, and
immediately destroy or return to the Licensor (at the Licensor's option) all
copies of the Software, or derivations or variations thereto, then in your
possession, custody or control and, in the case of destruction, certify to
the Licensor that you have done so.
11.    You may not transfer, assign, charge or otherwise dispose of this
Agreement, or any of your rights or obligations arising under it, without
our prior written consent.
12.    We may transfer, assign, charge, sub-contract or otherwise dispose of
this Agreement, or any of our rights or obligations under it, at any time
during the term of the Agreement.
13.    All notices given by you to us must be given to INOV via e-mail at antonio.grilo@inov.pt.
We may give notice to you at either the e-mail or postal address you
provided to us when registering to download the Software. Notice will be
deemed received and properly served immediately when posted on our website,
24 hours after an e-mail is sent, or three days after the date of posting of
any letter. In proving the service of any notice, it will be sufficient to
prove, in the case of a letter, that such letter was properly addressed,
stamped and placed in the post and, in the case of an e-mail, that such
e-mail was sent to the specified e-mail address of the addressee.
14.    This Agreement and any document expressly referred to in it
represents the entire agreement between us in relation to the licensing of
the Software and supersedes any prior agreement, understanding or
arrangement between us, whether oral or in writing.
15.    A person who is not a party to this Agreement shall have no right
under the Contracts (Rights of Third Parties) Act 1999 to enforce any of its
terms.
16.    INOV reserves the right to change this Agreement at any time without
prior notice. INOV will notify you of any such change or by posting an
updated version of this agreement online. By clicking on the ?Accept? button
at the bottom of an updated version you will agree to the terms of the
varied version which will bind you and your employees.
17.    This Agreement is governed by English law. Any dispute arising from,
or related to, any term of this Agreement shall be subject to the
non-exclusive jurisdiction of the courts of Portugal.

author          = "Francisco Rocha, Antonio Grilo",
date            = "17-10-2008",
filename        = "DTSNTransport.h",
address         = "INOV, Rua Alves Redol, No. 9, 1000-029 Lisboa, Portugal",
telephone       = "+351 213100226",
FAX             = "+351 213100226",
email           = "antonio.grilo@inov.pt",
description = "DTSN definitions and main parameters."
 
Copyright (c) 2008 INOV.
All Rights Reserved
*/

#ifndef DTSNTRANSPORT_H
#define DTSNTRANSPORT_H

#define DTSNCLIENTID "DTSNEngineClientID"

#define INODECACHEF
#define CACHINGPROB 100
#define RAND_TOP 100

#define DEBUG
#define SESSIONDEBUG
#define RECEIVEDEBUG
#define NACKDEBUG
#define ACKDEBUG
#define EARDEBUG
#define INODEDEBUG

//#define WITH_IFLASH

#include "queue.h"

// to get IFLASH_DTSN_SESSION_NUM
#ifdef WITH_IFLASH
#include "NetProg_platform.h"
#endif

#include <stdlib.h>
#ifdef SIM
  #include <assert.h>
#endif

#ifndef FAMILY
#define FAMILY 0
#endif

#ifdef SIM
  #define DTSN_SESSION_SIZE 1 
  #define DTSN_WINDOW_SIZE 50
  #define TASK_CACHE_SIZE 5
  #define DTSN_INODE_CACHE 50
#else

#if(FAMILY == 0)
  #ifndef DTSN_SESSION_SIZE
    #define DTSN_SESSION_SIZE 4
  #endif
  #ifndef DTSN_WINDOW_SIZE
    #define DTSN_WINDOW_SIZE 2
  #endif
  #ifndef TASK_CACHE_SIZE
    #define TASK_CACHE_SIZE 3
  #endif
  #ifndef DTSN_INODE_CACHE
    #define DTSN_INODE_CACHE 4
  #endif
#elif(FAMILY == 1)
  #ifndef DTSN_SESSION_SIZE
    #define DTSN_SESSION_SIZE 15
  #endif
  #ifndef DTSN_WINDOWS_SIZE
    #define DTSN_WINDOW_SIZE 4
  #endif
  #ifndef TASK_CACHE_SIZE
    #define TASK_CACHE_SIZE 3
  #endif
  #ifndef DTSN_INODE_CACHE
    #define DTSN_INODE_CACHE 4
  #endif 
#endif

#endif



//Constants
enum{
  DTSN_ACKWIN_SIZE = (DTSN_WINDOW_SIZE/2), // Acknowledgment window size
  
  DTSN_EAR_TIMEOUT = 0, //10, //80, //40, // ACK request timeout
  DTSN_ACT_TIMEOUT_S = 30, //90, //660, //400, // Activity timeout at sender
  DTSN_ACT_TIMEOUT_R = 40, //100, //680, //500, // Activity timeout at receiver
  DTSN_BASE_TIMEOUT = 250, // Base timeout in milliseconds
  
  DTSN_EAR_RETRIES = 4, //200, // Number of times the sender will try to get confirmation on sent messages
  
  DTSN_MAX_SEQNOs = 256, // maximum sequence number
  
  NO_TIMEOUT = 0,
  EAR_TIMEOUT = 11,
  S_ACT_TIMEOUT = 22,
  R_ACT_TIMEOUT = 33,
  
  QUEUE_FULL = 9,
  
  DTSN_SESSION_NOT_FOUND = DTSN_SESSION_SIZE + 1 
};

#include "bitvector.h"

typedef struct taskel{
  message_t taskMsg;
  am_id_t taskID;
  uint8_t taskLen;
} TaskElement;

// DTSN Session identifier
typedef nx_struct DTSNSessionID_{
  nx_am_addr_t sourceAddr;
  nx_am_addr_t destAddr;
  nx_uint8_t AMID;
  nx_uint8_t sessionNumber;
} DTSNSessionID;


// DTSN Header Structure
typedef nx_struct DTSNHeader_{
  DTSNSessionID sessionID;
  nx_uint8_t seqNo;
  nx_struct flags_{
    nx_uint8_t reTx:1;
    nx_uint8_t ack:1;
    nx_uint8_t nack:1;
    nx_uint8_t ear:1;
    nx_uint8_t data:1;
    nx_uint8_t rst:1;
    nx_uint8_t disc:1;
  } flags;
} DTSNHeader;

// DTSN Session structure
typedef struct DTSNSession_{
  DTSNSessionID sessionID;
  struct sFlags_{
    uint8_t valid:1;
    uint8_t wf_ack:1;
    uint8_t rst:1;
  } sFlags;
  uint8_t EARAttempts;
  uint8_t timeoutID;
  uint16_t timeout;
  uint8_t maxSeqNo;
  uint8_t lastEAR;
  Queue buffer;
} DTSNSession;

/* typedef struct DTSNStats_ {
  uint16_t dtsns_sentSender;
  uint16_t dtsns_sentINode;
  uint16_t dtsns_sentRcv;
  
  uint16_t dtsns_Nacks;
  uint16_t dtsns_Acks;
  uint16_t dtsns_Rtx;
  uint16_t dtsns_EAR;
  
  uint16_t dtsns_packetsRcv;
  uint16_t dtsns_packetsSentToApp;
  
  uint16_t dtsns_firstPacket;
  uint16_t dtsns_lastPacket;
} DTSNStats;
 */
// debug functions
void dbgDTSNHeader(DTSNHeader *hdr){
  dbg("DTSN", "[INI][DTSN] DTSNHeader\n");
  dbg("DTSN", "Session:\n\t\tSource: %d\n\t\tDestination: %d\n\t\tSession Number: %d\n\t\tAMID: %d\n\t\tSequence Number: %d\n", 
    hdr->sessionID.sourceAddr, hdr->sessionID.destAddr, hdr->sessionID.sessionNumber, hdr->sessionID.AMID, hdr->seqNo);
  dbg("DTSN", "Flags:\n\t\tData: %d\n\t\tAck: %d\n\t\tNack: %d\n\t\tEAR: %d\n\t\tReTX: %d\n\t\tRST: %d\n", 
    hdr->flags.data, hdr->flags.ack, hdr->flags.nack, hdr->flags.ear, hdr->flags.reTx, hdr->flags.rst);
  dbg("DTSN", "[END][DTSN] DTSNHeader\n");
}

void dbgSessionID(DTSNSessionID *id){
  dbg("DTSN", "Session ID: Source: %d | Destination: %d | AMID: %d | SessionNo: %d\n", 
    id->sourceAddr, id->destAddr, id->AMID, id->sessionNumber);
}

void dbgSession(DTSNSession *session){
  dbg("DTSN", "[INI] Session debug.\n");
  dbgSessionID(&(session->sessionID));
  dbg("DTSN", "Flags:\n\t\tValid: %d\n\t\tWF_ACK: %d\n", session->sFlags.valid, session->sFlags.wf_ack);
  dbg("DTSN", "Session:\n\t\tEARAttempts: %d\n\t\tTimeoutID: %d\n\t\tTimeout: %d\n\t\tMaxSeqNo: %d\n\t\tLast EAR: %d\n\t\tRST: %d\n", 
    session->EARAttempts, session->timeoutID, session->timeout, session->maxSeqNo, session->lastEAR, session->sFlags.rst); // \t\tSenderEAR: %d\n // , session->senderEAR
  dbg("DTSN", "[END] Session debug.\n");
}

void dbgDTSNPayload( uint8_t *data, uint8_t size ){

	int i;

	dbg( "DTSN", "\tMultiHopPayload:\n");
	dbg( "DTSN", "\t\tdata : ");
	for( i = 0; i < size; i++ )
	    dbg_clear("DTSN", "%d(%x)\n", *(data+i), data+i);
	dbg_clear("DTSN","\n");
		
}

/* void printStats(DTSNStats *stats){
  
  dbg("DTSN", "Transmissions (sender): %d\n", stats->dtsns_sentSender);
  
  dbg("DTSN", "First packet sent @%d (sender)\n", stats->dtsns_firstPacket);
  
  dbg("DTSN", "ReTransmissions (sender): %d\n", stats->dtsns_Rtx);
  
  dbg("DTSN", "EAR packets (sender): %d\n", stats->dtsns_EAR);
  
  dbg("DTSN", "Transmissions (INode): %d\n", stats->dtsns_sentINode);
  
  dbg("DTSN", "Received packets (Receiver): %d\n", stats->dtsns_packetsRcv);
  
  dbg("DTSN", "Packets sent to App (Receiver): %d\n", stats->dtsns_packetsSentToApp);
  
  dbg("DTSN", "Last packet received @%d (Receiver)\n", stats->dtsns_lastPacket);
  
  dbg("DTSN", "Transmissions (Receiver): %d\n", stats->dtsns_sentRcv);
  
  dbg("DTSN", "Nacks (Receiver): %d\n", stats->dtsns_Nacks);
  
  dbg("DTSN", "Acks (Receiver): %d\n", stats->dtsns_Acks);
} */

#endif
